from ..overrides import override
from ..importer import modules

Dee = modules['Dee'].introspection_module
from gi.repository import GLib

__all__ = []

class Model(Dee.Model):

    def __init__(self):
        Dee.Model.__init__(self)

    def set_schema (self, *args):
        self.set_schema_full (tuple(args))
    
    def _build_row (self, args):
        result = []
        for i, arg in enumerate(args):
            if isinstance(arg, GLib.Variant):
                result.append(arg)
            else:
                result.append(GLib.Variant(self.get_column_schema(i), arg))
        return tuple(result)
    
    def prepend (self, *args):
        return self.prepend_row (self._build_row(args))
    
    def append (self, *args):
        return self.append_row (self._build_row(args))
    
    def insert (self, pos, *args):
        return self.insert_row (pos, self._build_row(args))
    
    def insert_before (self, iter, *args):
        return self.insert_row_before (iter, self._build_row(args))
    
    def get_schema (self):
        return Dee.Model.get_schema(self)[0]

Model = override(Model)
__all__.append('Model')

